<script setup lang="ts">
import { useRoute, useRouter } from 'vue-router';
import { reactive, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import AuthUserSelect from './components/auth-user-select.vue';
import { authUserList, authUserChecked } from '@/api/system/role';
import { parseDateToStr } from '@/utils/date-utils';
import useTabsStore from '@/store/modules/tabs';
import useDictStore from '@/store/modules/dict';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
const { t } = useI18n();
const tabsStore = useTabsStore();
const { getDict } = useDictStore();
const route = useRoute();
const router = useRouter();

// 获取地址栏参数
const roleId = route.params && (route.params.roleId as string);
const roleName = route.query && (route.query.roleName as string);

/**字典数据 */
let dict: {
  /**状态 */
  sysNormalDisable: DictType[];
} = reactive({
  sysNormalDisable: [],
});

/**查询参数 */
let queryParams = reactive({
  /**登录账号 */
  userName: '',
  /**手机号码 */
  phone: '',
  /**用户状态 */
  status: undefined,
  /**角色ID */
  roleId: roleId,
  /**是否已分配 */
  auth: true,
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    userName: '',
    phone: '',
    status: undefined,
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.system.role.userId'),
    dataIndex: 'userId',
    align: 'center',
  },
  {
    title: t('views.system.role.account'),
    dataIndex: 'userName',
    align: 'left',
  },
  {
    title: t('views.system.role.userName'),
    dataIndex: 'nickName',
    align: 'left',
  },
  {
    title: t('views.system.role.phone'),
    dataIndex: 'phone',
    align: 'left',
  },
  {
    title: t('views.system.role.email'),
    dataIndex: 'email',
    align: 'left',
  },
  {
    title: t('views.system.role.userStaus'),
    dataIndex: 'status',
    key: 'status',
    align: 'center',
  },
  {
    title: t('views.system.role.createTime'),
    dataIndex: 'createTime',
    align: 'center',
    customRender(opt) {
      if (+opt.value <= 0) return '';
      return parseDateToStr(+opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'userId',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**选择用户框是否显示 */
  openBySelectUser: boolean;
  /**标题 */
  title: string;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openBySelectUser: false,
  title: t('views.system.role.distributeUser'),
});

/**
 * 对话框弹出显示为 选择用户
 */
function fnModalVisibleBySelectUser() {
  modalState.openBySelectUser = true;
}

/**
 * 对话框弹出确认执行函数
 * 授权用户
 */
function fnModalOk(userIds: string[] | number[]) {
  if (userIds.length <= 0) {
    message.error(t('views.system.role.selectPls'), 2);
    return;
  }
  const key = 'authUserChecked';
  message.loading({ content: t('common.loading'), key });
  authUserChecked({
    checked: true,
    userIds: userIds.map(v => Number(v)),
    roleId: Number(roleId),
  }).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      modalState.openBySelectUser = false;
      message.success({
        content: t('views.system.role.suss', {
          oper: t('views.system.role.giveUser'),
        }),
        key,
        duration: 3,
      });
      fnGetList(1);
    } else {
      message.error({
        content: `${res.msg}`,
        key,
        duration: 3,
      });
    }
  });
}

/**
 * 取消授权
 * @param userId 用户编号ID
 */
function fnRecordDelete(userId: string | number) {
  if (userId === '0') {
    userId = tableState.selectedRowKeys.join(',');
  }
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.system.role.cancelSure', { userId: userId }),
    onOk() {
      const key = 'authUserChecked';
      message.loading({ content: t('common.loading'), key });
      const userIds = `${userId}`.split(',').map(v => Number(v));
      authUserChecked({ checked: false, userIds, roleId: Number(roleId) }).then(
        res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('views.system.role.suss', {
                oper: t('views.system.role.cancelGive'),
              }),
              key,
              duration: 3,
            });
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              key,
              duration: 3,
            });
          }
        }
      );
    },
  });
}

/**关闭跳转 */
function fnClose() {
  const to = tabsStore.tabClose(route.path);
  if (to) {
    router.push(to);
  } else {
    router.back();
  }
}

/**查询角色已授权用户列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  authUserList(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      const { total, rows } = res.data;
      tablePagination.total = total;
      tableState.data = rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('sys_normal_disable')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.sysNormalDisable = resArr[0].value;
    }
  });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.roleName')"
              name="roleName"
            >
              <a-input :value="roleName" disabled></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.account')"
              name="userName"
            >
              <a-input
                v-model:value="queryParams.userName"
                allow-clear
                :maxlength="30"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.system.role.phone')" name="phone">
              <a-input
                v-model:value="queryParams.phone"
                allow-clear
                :maxlength="11"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.system.role.userStaus')"
              name="status"
            >
              <a-select
                v-model:value="queryParams.status"
                allow-clear
                :options="dict.sysNormalDisable"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}</a-button
                >
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}</a-button
                >
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button type="default" @click.prevent="fnClose()">
            <template #icon><CloseOutlined /></template>
            {{ t('common.cancel') }}
          </a-button>
          <a-button
            type="primary"
            @click.prevent="fnModalVisibleBySelectUser()"
            v-perms:has="['system:role:add']"
          >
            <template #icon><UsergroupAddOutlined /></template>
            {{ t('views.system.role.distributeUser') }}
          </a-button>
          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            @click.prevent="fnRecordDelete('0')"
            v-perms:has="['system:role:remove']"
          >
            <template #icon><UsergroupDeleteOutlined /></template>
            {{ t('views.system.role.batchCancel') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default"
                    >{{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle"
                    >{{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small"
                    >{{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="userId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :scroll="{ x: true }"
        :pagination="tablePagination"
        :row-selection="{
          type: 'checkbox',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'status'">
            <DictTag :options="dict.sysNormalDisable" :value="record.status" />
          </template>
          <template v-if="column.key === 'userId'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{
                  t('views.system.role.cancelGive')
                }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.userId)"
                  v-perms:has="['system:role:remove']"
                >
                  <template #icon><UserDeleteOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 分配用户选择框 -->
    <AuthUserSelect
      :role-id="roleId"
      :title="modalState.title"
      v-model:open="modalState.openBySelectUser"
      @ok="fnModalOk"
    />
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
